<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleKinematicConstraints.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleKinematicConstraints_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleKinematicConstraints.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This example demonstrates how Moco solves problems with kinematic constraints and includes a visualization of the Lagrange multipliers that Moco solves for.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># OpenSim Moco: exampleKinematicConstraints.py                               #</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Copyright (c) 2020 Stanford University and the Authors                     #</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"># Author(s): Christopher Dembia                                              #</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"># Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    #</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"># not use this file except in compliance with the License. You may obtain a  #</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"># copy of the License at http://www.apache.org/licenses/LICENSE-2.0          #</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># Unless required by applicable law or agreed to in writing, software        #</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          #</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># See the License for the specific language governing permissions and        #</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"># limitations under the License.                                             #</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"># This example illustrates how Moco handles kinematic constraints with a model</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"># of a planar point mass with degrees of freedom tx and ty that is constrained</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"># to move along a parabola ty = tx^2. This example plots the trajectory of the</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"># point mass, which follows the parabola, and multiplies the kinematic</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"># constraint Jacobian and the Lagrange multipliers to visualize the constraint</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"># forces that Moco produces to ensure the point mass remains on the parabola.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"># Lastly, this example computes the error in the equations of motion, showing</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"># how the constraint forces are necessary for satisfying the equations of</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"># motion.</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"># The constraint ty = tx^2 is represented internally as 0 = tx^2 - ty.</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"># The kinematic constraint Jacobian contains the partial derivative of</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"># each kinematic constraint (only one constraint in this case) with respect to</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"># each degree of freedom:</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment">#   G = [2*tx, -1]</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"># This example is related to an explanation of kinematic constraints in the</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"># appendix of the Moco paper.</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">import</span> numpy <span class="keyword">as</span> np</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;model = osim.Model()</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;model.setName(<span class="stringliteral">&#39;planar_point_mass&#39;</span>)</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;g = abs(model.get_gravity()[1])</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment"># We use an intermediate massless body for the X translation degree of freedom.</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;massless = osim.Body(<span class="stringliteral">&#39;massless&#39;</span>, 0, osim.Vec3(0), osim.Inertia(0))</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;model.addBody(massless);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;mass = 1.0</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;body = osim.Body(<span class="stringliteral">&#39;body&#39;</span>, mass, osim.Vec3(0), osim.Inertia(0))</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;model.addBody(body)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;body.attachGeometry(osim.Sphere(0.05))</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;jointX = osim.SliderJoint(<span class="stringliteral">&#39;tx&#39;</span>, model.getGround(), massless)</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;coordX = jointX.updCoordinate(osim.SliderJoint.Coord_TranslationX)</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;coordX.setName(<span class="stringliteral">&#39;tx&#39;</span>)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;model.addJoint(jointX)</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment"># The joint&#39;s x axis must point in the global &quot;+y&quot; direction.</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;jointY = osim.SliderJoint(<span class="stringliteral">&#39;ty&#39;</span>,</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;                          massless, osim.Vec3(0), osim.Vec3(0, 0, 0.5 * np.pi),</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;                          body, osim.Vec3(0), osim.Vec3(0, 0, 0.5 * np.pi))</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;coordY = jointY.updCoordinate(osim.SliderJoint.Coord_TranslationX)</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;coordY.setName(<span class="stringliteral">&#39;ty&#39;</span>)</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;model.addJoint(jointY)</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment"># Add the kinematic constraint ty = tx^2.</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;constraint = osim.CoordinateCouplerConstraint()</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;independentCoords = osim.ArrayStr()</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;independentCoords.append(<span class="stringliteral">&#39;tx&#39;</span>)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;constraint.setIndependentCoordinateNames(independentCoords)</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;constraint.setDependentCoordinateName(<span class="stringliteral">&#39;ty&#39;</span>)</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;coefficients = osim.Vector(3, 0) <span class="comment"># 3 elements initialized to 0.</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment"># The polynomial is c0*tx^2 + c1*tx + c2; set c0 = 1, c1 = c2 = 0.</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;coefficients.set(0, 1)</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;constraint.setFunction(osim.PolynomialFunction(coefficients))</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;model.addConstraint(constraint)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;study = osim.MocoStudy()</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;problem = study.updProblem()</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;problem.setModel(model)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;phase0 = problem.getPhase(0)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment"># Setting stricter bounds for the speeds improves convergence.</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;phase0.setDefaultSpeedBounds(osim.MocoBounds(-5, 5))</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;problem.setTimeBounds(0, 0.8)</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment"># Start the motion at (-1, 1).</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/tx/tx/value&#39;</span>, [-2, 2], -1.0)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/jointset/ty/ty/value&#39;</span>, [-2, 2], 1.0)</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;solver = study.initCasADiSolver()</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;solution = study.solve()</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment"># If matplotlib is installed, plot the trajectory of the mass and the</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment"># constraint force applied to the mass throughout the motion.</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;plot = <span class="keyword">False</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment"># The following environment variable is set during automated testing.</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keywordflow">if</span> os.getenv(<span class="stringliteral">&#39;OPENSIM_USE_VISUALIZER&#39;</span>) != <span class="stringliteral">&#39;0&#39;</span>:</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">try</span>:</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keyword">import</span> pylab <span class="keyword">as</span> pl</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keyword">from</span> scipy.interpolate <span class="keyword">import</span> InterpolatedUnivariateSpline</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        plot = <span class="keyword">True</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordflow">except</span>:</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        print(<span class="stringliteral">&#39;Skipping plotting&#39;</span>)</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keywordflow">if</span> plot:</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="comment"># Create a figure.</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    fig = pl.figure()</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    ax = fig.add_subplot(1, 1, 1)</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    ax.set_xlabel(<span class="stringliteral">&#39;tx&#39;</span>)</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    ax.set_ylabel(<span class="stringliteral">&#39;ty&#39;</span>)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160; </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="comment"># Extract the trajectory from the solution.</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    time = solution.getTimeMat()</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    tx = solution.getStateMat(<span class="stringliteral">&#39;/jointset/tx/tx/value&#39;</span>)</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    ty = solution.getStateMat(<span class="stringliteral">&#39;/jointset/ty/ty/value&#39;</span>)</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    multiplier = -solution.getMultiplierMat(solution.getMultiplierNames()[0])</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    print(<span class="stringliteral">&#39;Number of multipliers: %i&#39;</span> % len(solution.getMultiplierNames()))</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="comment"># Plot the trajectory.</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    ax.set_aspect(<span class="stringliteral">&#39;equal&#39;</span>)</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    pl.plot(tx, ty, color=<span class="stringliteral">&#39;black&#39;</span>)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160; </div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="comment"># Compute generalized accelerations from the solution trajectory, for use</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="comment"># in computing the residual of the equations of motion.</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    txSpline = InterpolatedUnivariateSpline(time, tx)</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="comment"># Evaluate the second derivative of the spline.</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    accelx = txSpline(time, 2)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    tySpline = InterpolatedUnivariateSpline(time, ty)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    accely = tySpline(time, 2)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="comment"># Loop through the trajectory and compute the constraint force.</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    model.initSystem()</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    statesTraj = solution.exportToStatesTrajectory(model)</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    matter = model.getMatterSubsystem()</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    constraintJacobian = osim.Matrix()</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    itime = 0</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keywordflow">while</span> itime &lt; statesTraj.getSize():</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        state = statesTraj.get(itime)</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        model.realizePosition(state)</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="comment"># Calculate the position-level constraint Jacobian, 2 x 1 (number of</span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="comment"># degrees of freedom by number of constraints).</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="comment"># Pq = [2 * tx, -1]</span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        matter.calcPq(state, constraintJacobian)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        jac = np.array([constraintJacobian.get(0, 0),</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                        constraintJacobian.get(1, 0)])</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="comment"># The constraint generates generalized forces G^T * lambda.</span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        constraintForces = jac * multiplier[itime]</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="comment"># Scale down the force vector so it can be easily visualized with the</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="comment"># point mass trajectory.</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        constraintForcesViz = 0.010 * constraintForces</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        pl.arrow(tx[itime], ty[itime], constraintForcesViz[0],</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                 constraintForcesViz[1], width=0.005, color=<span class="stringliteral">&#39;blue&#39;</span>)</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160; </div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="comment"># Residual = F - ma</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        residualx = +constraintForces[0] - mass * accelx[itime]</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        residualy = -mass * g + constraintForces[1] - mass * accely[itime]</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        print(</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            <span class="stringliteral">&#39;time %f: residuals: %f, %f&#39;</span> % (time[itime], residualx, residualy))</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160; </div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="comment"># We plot the constraint force for every 10th time point in the solution</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="comment"># to avoid cluttering the plot.</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        itime += 10</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160; </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    pl.show()</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160; </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
